#lang racket

(provide (contract-out
     [*required_bits_table* hash?]
     [*required_ec_table* hash?]
     [*required_group_table* hash?]
     ))

(define *required_bits_table*
  '#hash(
         ("1-L" . 19)
         ("1-M" . 16)
         ("1-Q" . 13)
         ("1-H" . 9)
         ("2-L" . 34)
         ("2-M" . 28)
         ("2-Q" . 22)
         ("2-H" . 16)
         ("3-L" . 55)
         ("3-M" . 44)
         ("3-Q" . 34)
         ("3-H" . 26)
         ("4-L" . 80)
         ("4-M" . 64)
         ("4-Q" . 48)
         ("4-H" . 36)
         ("5-L" . 108)
         ("5-M" . 86)
         ("5-Q" . 62)
         ("5-H" . 46)
         ("6-L" . 136)
         ("6-M" . 108)
         ("6-Q" . 76)
         ("6-H" . 60)
         ("7-L" . 156)
         ("7-M" . 124)
         ("7-Q" . 88)
         ("7-H" . 66)
         ("8-L" . 194)
         ("8-M" . 154)
         ("8-Q" . 110)
         ("8-H" . 86)
         ("9-L" . 232)
         ("9-M" . 182)
         ("9-Q" . 132)
         ("9-H" . 100)
         ("10-L" . 274)
         ("10-M" . 216)
         ("10-Q" . 154)
         ("10-H" . 122)
         ("11-L" . 324)
         ("11-M" . 254)
         ("11-Q" . 180)
         ("11-H" . 140)
         ("12-L" . 370)
         ("12-M" . 290)
         ("12-Q" . 206)
         ("12-H" . 158)
         ("13-L" . 428)
         ("13-M" . 334)
         ("13-Q" . 244)
         ("13-H" . 180)
         ("14-L" . 461)
         ("14-M" . 365)
         ("14-Q" . 261)
         ("14-H" . 197)
         ("15-L" . 523)
         ("15-M" . 415)
         ("15-Q" . 295)
         ("15-H" . 223)
         ("16-L" . 589)
         ("16-M" . 453)
         ("16-Q" . 325)
         ("16-H" . 253)
         ("17-L" . 647)
         ("17-M" . 507)
         ("17-Q" . 367)
         ("17-H" . 283)
         ("18-L" . 721)
         ("18-M" . 563)
         ("18-Q" . 397)
         ("18-H" . 313)
         ("19-L" . 795)
         ("19-M" . 627)
         ("19-Q" . 445)
         ("19-H" . 341)
         ("20-L" . 861)
         ("20-M" . 669)
         ("20-Q" . 485)
         ("20-H" . 385)
         ("21-L" . 932)
         ("21-M" . 714)
         ("21-Q" . 512)
         ("21-H" . 406)
         ("22-L" . 1006)
         ("22-M" . 782)
         ("22-Q" . 568)
         ("22-H" . 442)
         ("23-L" . 1094)
         ("23-M" . 860)
         ("23-Q" . 614)
         ("23-H" . 464)
         ("24-L" . 1174)
         ("24-M" . 914)
         ("24-Q" . 664)
         ("24-H" . 514)
         ("25-L" . 1276)
         ("25-M" . 1000)
         ("25-Q" . 718)
         ("25-H" . 538)
         ("26-L" . 1370)
         ("26-M" . 1062)
         ("26-Q" . 754)
         ("26-H" . 596)
         ("27-L" . 1468)
         ("27-M" . 1128)
         ("27-Q" . 808)
         ("27-H" . 628)
         ("28-L" . 1531)
         ("28-M" . 1193)
         ("28-Q" . 871)
         ("28-H" . 661)
         ("29-L" . 1631)
         ("29-M" . 1267)
         ("29-Q" . 911)
         ("29-H" . 701)
         ("30-L" . 1735)
         ("30-M" . 1373)
         ("30-Q" . 985)
         ("30-H" . 745)
         ("31-L" . 1843)
         ("31-M" . 1455)
         ("31-Q" . 1033)
         ("31-H" . 793)
         ("32-L" . 1955)
         ("32-M" . 1541)
         ("32-Q" . 1115)
         ("32-H" . 845)
         ("33-L" . 2071)
         ("33-M" . 1631)
         ("33-Q" . 1171)
         ("33-H" . 901)
         ("34-L" . 2191)
         ("34-M" . 1725)
         ("34-Q" . 1231)
         ("34-H" . 961)
         ("35-L" . 2306)
         ("35-M" . 1812)
         ("35-Q" . 1286)
         ("35-H" . 986)
         ("36-L" . 2434)
         ("36-M" . 1914)
         ("36-Q" . 1354)
         ("36-H" . 1054)
         ("37-L" . 2566)
         ("37-M" . 1992)
         ("37-Q" . 1426)
         ("37-H" . 1096)
         ("38-L" . 2702)
         ("38-M" . 2102)
         ("38-Q" . 1502)
         ("38-H" . 1142)
         ("39-L" . 2812)
         ("39-M" . 2216)
         ("39-Q" . 1582)
         ("39-H" . 1222)
         ("40-L" . 2956)
         ("40-M" . 2334)
         ("40-Q" . 1666)
         ("40-H" . 1276)
         ))

(define *required_ec_table*
  '#hash(
         ("1-L" . 7)
         ("1-M" . 10)
         ("1-Q" . 13)
         ("1-H" . 17)
         ("2-L" . 10)
         ("2-M" . 16)
         ("2-Q" . 22)
         ("2-H" . 28)
         ("3-L" . 15)
         ("3-M" . 26)
         ("3-Q" . 18)
         ("3-H" . 22)
         ("4-L" . 20)
         ("4-M" . 18)
         ("4-Q" . 26)
         ("4-H" . 16)
         ("5-L" . 26)
         ("5-M" . 24)
         ("5-Q" . 18)
         ("5-H" . 22)
         ("6-L" . 18)
         ("6-M" . 16)
         ("6-Q" . 24)
         ("6-H" . 28)
         ("7-L" . 20)
         ("7-M" . 18)
         ("7-Q" . 18)
         ("7-H" . 26)
         ("8-L" . 24)
         ("8-M" . 22)
         ("8-Q" . 22)
         ("8-H" . 26)
         ("9-L" . 30)
         ("9-M" . 22)
         ("9-Q" . 20)
         ("9-H" . 24)
         ("10-L" . 18)
         ("10-M" . 26)
         ("10-Q" . 24)
         ("10-H" . 28)
         ("11-L" . 20)
         ("11-M" . 30)
         ("11-Q" . 28)
         ("11-H" . 24)
         ("12-L" . 24)
         ("12-M" . 22)
         ("12-Q" . 26)
         ("12-H" . 28)
         ("13-L" . 26)
         ("13-M" . 22)
         ("13-Q" . 24)
         ("13-H" . 22)
         ("14-L" . 30)
         ("14-M" . 24)
         ("14-Q" . 20)
         ("14-H" . 24)
         ("15-L" . 22)
         ("15-M" . 24)
         ("15-Q" . 30)
         ("15-H" . 24)
         ("16-L" . 24)
         ("16-M" . 28)
         ("16-Q" . 24)
         ("16-H" . 30)
         ("17-L" . 28)
         ("17-M" . 28)
         ("17-Q" . 28)
         ("17-H" . 28)
         ("18-L" . 30)
         ("18-M" . 26)
         ("18-Q" . 28)
         ("18-H" . 28)
         ("19-L" . 28)
         ("19-M" . 26)
         ("19-Q" . 26)
         ("19-H" . 26)
         ("20-L" . 28)
         ("20-M" . 26)
         ("20-Q" . 30)
         ("20-H" . 28)
         ("21-L" . 28)
         ("21-M" . 26)
         ("21-Q" . 28)
         ("21-H" . 30)
         ("22-L" . 28)
         ("22-M" . 28)
         ("22-Q" . 30)
         ("22-H" . 24)
         ("23-L" . 30)
         ("23-M" . 28)
         ("23-Q" . 30)
         ("23-H" . 30)
         ("24-L" . 30)
         ("24-M" . 28)
         ("24-Q" . 30)
         ("24-H" . 30)
         ("25-L" . 26)
         ("25-M" . 28)
         ("25-Q" . 30)
         ("25-H" . 30)
         ("26-L" . 28)
         ("26-M" . 28)
         ("26-Q" . 28)
         ("26-H" . 30)
         ("27-L" . 30)
         ("27-M" . 28)
         ("27-Q" . 30)
         ("27-H" . 30)
         ("28-L" . 30)
         ("28-M" . 28)
         ("28-Q" . 30)
         ("28-H" . 30)
         ("29-L" . 30)
         ("29-M" . 28)
         ("29-Q" . 30)
         ("29-H" . 30)
         ("30-L" . 30)
         ("30-M" . 28)
         ("30-Q" . 30)
         ("30-H" . 30)
         ("31-L" . 30)
         ("31-M" . 28)
         ("31-Q" . 30)
         ("31-H" . 30)
         ("32-L" . 30)
         ("32-M" . 28)
         ("32-Q" . 30)
         ("32-H" . 30)
         ("33-L" . 30)
         ("33-M" . 28)
         ("33-Q" . 30)
         ("33-H" . 30)
         ("34-L" . 30)
         ("34-M" . 28)
         ("34-Q" . 30)
         ("34-H" . 30)
         ("35-L" . 30)
         ("35-M" . 28)
         ("35-Q" . 30)
         ("35-H" . 30)
         ("36-L" . 30)
         ("36-M" . 28)
         ("36-Q" . 30)
         ("36-H" . 30)
         ("37-L" . 30)
         ("37-M" . 28)
         ("37-Q" . 30)
         ("37-H" . 30)
         ("38-L" . 30)
         ("38-M" . 28)
         ("38-Q" . 30)
         ("38-H" . 30)
         ("39-L" . 30)
         ("39-M" . 28)
         ("39-Q" . 30)
         ("39-H" . 30)
         ("40-L" . 30)
         ("40-M" . 28)
         ("40-Q" . 30)
         ("40-H" . 30)
         ))

(define *required_group_table*
  '#hash(
         ("1-L" . #((1 . 19) (0 . 0)))
         ("1-M" . #((1 . 16) (0 . 0)))
         ("1-Q" . #((1 . 13) (0 . 0)))
         ("1-H" . #((1 . 9) (0 . 0)))
         ("2-L" . #((1 . 34) (0 . 0)))
         ("2-M" . #((1 . 28) (0 . 0)))
         ("2-Q" . #((1 . 22) (0 . 0)))
         ("2-H" . #((1 . 16) (0 . 0)))
         ("3-L" . #((1 . 55) (0 . 0)))
         ("3-M" . #((1 . 44) (0 . 0)))
         ("3-Q" . #((2 . 17) (0 . 0)))
         ("3-H" . #((2 . 13) (0 . 0)))
         ("4-L" . #((1 . 80) (0 . 0)))
         ("4-M" . #((2 . 32) (0 . 0)))
         ("4-Q" . #((2 . 24) (0 . 0)))
         ("4-H" . #((4 . 9) (0 . 0)))
         ("5-L" . #((1 . 108) (0 . 0)))
         ("5-M" . #((2 . 43) (0 . 0)))
         ("5-Q" . #((2 . 15) (2 . 16)))
         ("5-H" . #((2 . 11) (2 . 12)))
         ("6-L" . #((2 . 68) (0 . 0)))
         ("6-M" . #((4 . 27) (0 . 0)))
         ("6-Q" . #((4 . 19) (0 . 0)))
         ("6-H" . #((4 . 15) (0 . 0)))
         ("7-L" . #((2 . 78) (0 . 0)))
         ("7-M" . #((4 . 31) (0 . 0)))
         ("7-Q" . #((2 . 14) (4 . 15)))
         ("7-H" . #((4 . 13) (1 . 14)))
         ("8-L" . #((2 . 97) (0 . 0)))
         ("8-M" . #((2 . 38) (2 . 39)))
         ("8-Q" . #((4 . 18) (2 . 19)))
         ("8-H" . #((4 . 14) (2 . 15)))
         ("9-L" . #((2 . 116) (0 . 0)))
         ("9-M" . #((3 . 36) (2 . 37)))
         ("9-Q" . #((4 . 16) (4 . 17)))
         ("9-H" . #((4 . 12) (4 . 13)))
         ("10-L" . #((2 . 68) (2 . 69)))
         ("10-M" . #((4 . 43) (1 . 44)))
         ("10-Q" . #((6 . 19) (2 . 20)))
         ("10-H" . #((6 . 15) (2 . 16)))
         ("11-L" . #((4 . 81) (0 . 0)))
         ("11-M" . #((1 . 50) (4 . 51)))
         ("11-Q" . #((4 . 22) (4 . 23)))
         ("11-H" . #((3 . 12) (8 . 13)))
         ("12-L" . #((2 . 92) (2 . 93)))
         ("12-M" . #((6 . 36) (2 . 37)))
         ("12-Q" . #((4 . 20) (6 . 21)))
         ("12-H" . #((7 . 14) (4 . 15)))
         ("13-L" . #((4 . 107) (0 . 0)))
         ("13-M" . #((8 . 37) (1 . 38)))
         ("13-Q" . #((8 . 20) (4 . 21)))
         ("13-H" . #((12 . 11) (4 . 12)))
         ("14-L" . #((3 . 115) (1 . 116)))
         ("14-M" . #((4 . 40) (5 . 41)))
         ("14-Q" . #((11 . 16) (5 . 17)))
         ("14-H" . #((11 . 12) (5 . 13)))
         ("15-L" . #((5 . 87) (1 . 88)))
         ("15-M" . #((5 . 41) (5 . 42)))
         ("15-Q" . #((5 . 24) (7 . 25)))
         ("15-H" . #((11 . 12) (7 . 13)))
         ("16-L" . #((5 . 98) (1 . 99)))
         ("16-M" . #((7 . 45) (3 . 46)))
         ("16-Q" . #((15 . 19) (2 . 20)))
         ("16-H" . #((3 . 15) (13 . 16)))
         ("17-L" . #((1 . 107) (5 . 108)))
         ("17-M" . #((10 . 46) (1 . 47)))
         ("17-Q" . #((1 . 22) (15 . 23)))
         ("17-H" . #((2 . 14) (17 . 15)))
         ("18-L" . #((5 . 120) (1 . 121)))
         ("18-M" . #((9 . 43) (4 . 44)))
         ("18-Q" . #((17 . 22) (1 . 23)))
         ("18-H" . #((2 . 14) (19 . 15)))
         ("19-L" . #((3 . 113) (4 . 114)))
         ("19-M" . #((3 . 44) (11 . 45)))
         ("19-Q" . #((17 . 21) (4 . 22)))
         ("19-H" . #((9 . 13) (16 . 14)))
         ("20-L" . #((3 . 107) (5 . 108)))
         ("20-M" . #((3 . 41) (13 . 42)))
         ("20-Q" . #((15 . 24) (5 . 25)))
         ("20-H" . #((15 . 15) (10 . 16)))
         ("21-L" . #((4 . 116) (4 . 117)))
         ("21-M" . #((17 . 42) (0 . 0)))
         ("21-Q" . #((17 . 22) (6 . 23)))
         ("21-H" . #((19 . 16) (6 . 17)))
         ("22-L" . #((2 . 111) (7 . 112)))
         ("22-M" . #((17 . 46) (0 . 0)))
         ("22-Q" . #((7 . 24) (16 . 25)))
         ("22-H" . #((34 . 13) (0 . 0)))
         ("23-L" . #((4 . 121) (5 . 122)))
         ("23-M" . #((4 . 47) (14 . 48)))
         ("23-Q" . #((11 . 24) (14 . 25)))
         ("23-H" . #((16 . 15) (14 . 16)))
         ("24-L" . #((6 . 117) (4 . 118)))
         ("24-M" . #((6 . 45) (14 . 46)))
         ("24-Q" . #((11 . 24) (16 . 25)))
         ("24-H" . #((30 . 16) (2 . 17)))
         ("25-L" . #((8 . 106) (4 . 107)))
         ("25-M" . #((8 . 47) (13 . 48)))
         ("25-Q" . #((7 . 24) (22 . 25)))
         ("25-H" . #((22 . 15) (13 . 16)))
         ("26-L" . #((10 . 114) (2 . 115)))
         ("26-M" . #((19 . 46) (4 . 47)))
         ("26-Q" . #((28 . 22) (6 . 23)))
         ("26-H" . #((33 . 16) (4 . 17)))
         ("27-L" . #((8 . 122) (4 . 123)))
         ("27-M" . #((22 . 45) (3 . 46)))
         ("27-Q" . #((8 . 23) (26 . 24)))
         ("27-H" . #((12 . 15) (28 . 16)))
         ("28-L" . #((3 . 117) (10 . 118)))
         ("28-M" . #((3 . 45) (23 . 46)))
         ("28-Q" . #((4 . 24) (31 . 25)))
         ("28-H" . #((11 . 15) (31 . 16)))
         ("29-L" . #((7 . 116) (7 . 117)))
         ("29-M" . #((21 . 45) (7 . 46)))
         ("29-Q" . #((1 . 23) (37 . 24)))
         ("29-H" . #((19 . 15) (26 . 16)))
         ("30-L" . #((5 . 115) (10 . 116)))
         ("30-M" . #((19 . 47) (10 . 48)))
         ("30-Q" . #((15 . 24) (25 . 25)))
         ("30-H" . #((23 . 15) (25 . 16)))
         ("31-L" . #((13 . 115) (3 . 116)))
         ("31-M" . #((2 . 46) (29 . 47)))
         ("31-Q" . #((42 . 24) (1 . 25)))
         ("31-H" . #((23 . 15) (28 . 16)))
         ("32-L" . #((17 . 115) (0 . 0)))
         ("32-M" . #((10 . 46) (23 . 47)))
         ("32-Q" . #((10 . 24) (35 . 25)))
         ("32-H" . #((19 . 15) (35 . 16)))
         ("33-L" . #((17 . 115) (1 . 116)))
         ("33-M" . #((14 . 46) (21 . 47)))
         ("33-Q" . #((29 . 24) (19 . 25)))
         ("33-H" . #((11 . 15) (46 . 16)))
         ("34-L" . #((13 . 115) (6 . 116)))
         ("34-M" . #((14 . 46) (23 . 47)))
         ("34-Q" . #((44 . 24) (7 . 25)))
         ("34-H" . #((59 . 16) (1 . 17)))
         ("35-L" . #((12 . 121) (7 . 122)))
         ("35-M" . #((12 . 47) (26 . 48)))
         ("35-Q" . #((39 . 24) (14 . 25)))
         ("35-H" . #((22 . 15) (41 . 16)))
         ("36-L" . #((6 . 121) (14 . 122)))
         ("36-M" . #((6 . 47) (34 . 48)))
         ("36-Q" . #((46 . 24) (10 . 25)))
         ("36-H" . #((2 . 15) (64 . 16)))
         ("37-L" . #((17 . 122) (4 . 123)))
         ("37-M" . #((29 . 46) (14 . 47)))
         ("37-Q" . #((49 . 24) (10 . 25)))
         ("37-H" . #((24 . 15) (46 . 16)))
         ("38-L" . #((4 . 122) (18 . 123)))
         ("38-M" . #((13 . 46) (32 . 47)))
         ("38-Q" . #((48 . 24) (14 . 25)))
         ("38-H" . #((42 . 15) (32 . 16)))
         ("39-L" . #((20 . 117) (4 . 118)))
         ("39-M" . #((40 . 47) (7 . 48)))
         ("39-Q" . #((43 . 24) (22 . 25)))
         ("39-H" . #((10 . 15) (67 . 16)))
         ("40-L" . #((19 . 118) (6 . 119)))
         ("40-M" . #((18 . 47) (31 . 48)))
         ("40-Q" . #((34 . 24) (34 . 25)))
         ("40-H" . #((20 . 15) (61 . 16)))
         ))

